
build:
  stage: build
  image: maven:3.8.2-jdk-11
  script:
    - mvn clean install

test:
  stage: test
  image: maven:3.8.2-jdk-11
  script:
    - mvn test

deploy:
  stage: deploy
  image: adoptopenjdk/openjdk11:jre-11.0.10_9-alpine
  script:
    - java -jar target/SpringBootHelloWorld-0.0.1-SNAPSHOT.jar &
    - sleep 120
    - exit 0
  environment:
    name: production
    url: https://academy.esempio.com

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Compiling the code..."
    - echo "Compile complete."

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - sleep 60
    - echo "Code coverage is 90%"

lint-test-job:   # This job also runs in the test stage.
  stage: test    # It can run at the same time as unit-test-job (in parallel).
  script:
    - echo "Linting code... This will take about 10 seconds."
    - sleep 10
    - echo "No lint issues found."

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  environment: production
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."

